
#include <std_msgs/UInt64.h>
#include <std_msgs/UInt16.h>
#include <std_msgs/Byte.h>
#include <std_msgs/Bool.h>
#include <std_msgs/ByteMultiArray.h>
#include <std_msgs/Float32.h>
#include <std_msgs/String.h>
#include <std_msgs/UInt8.h>
#include <std_msgs/Char.h>
#include <std_msgs/Float64MultiArray.h>
#include <std_msgs/UInt32.h>
#include <std_msgs/Header.h>
#include <std_msgs/Int16MultiArray.h>
#include <std_msgs/UInt32MultiArray.h>
#include <std_msgs/Int16.h>
#include <std_msgs/UInt16MultiArray.h>
#include <std_msgs/UInt8MultiArray.h>
#include <std_msgs/MultiArrayDimension.h>
#include <std_msgs/Int64.h>
#include <std_msgs/Time.h>
#include <std_msgs/Int64MultiArray.h>
#include <std_msgs/Empty.h>
#include <std_msgs/Int8MultiArray.h>
#include <std_msgs/MultiArrayLayout.h>
#include <std_msgs/UInt64MultiArray.h>
#include <std_msgs/Int8.h>
#include <std_msgs/Int32.h>
#include <std_msgs/Float64.h>
#include <std_msgs/ColorRGBA.h>
#include <std_msgs/Duration.h>
#include <std_msgs/Float32MultiArray.h>
#include <std_msgs/Int32MultiArray.h>

#include "ros_msg_transporter.hpp"
#include "RosLib.hpp"
#include <rtt/types/TransportPlugin.hpp>
#include <rtt/types/TypekitPlugin.hpp>

namespace ros_integration {
  using namespace RTT;
    struct ROSstd_msgsPlugin
      : public types::TransportPlugin
    {
      bool registerTransport(std::string name, types::TypeInfo* ti)
      {
                   if(name == "/std_msgs/UInt64")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::UInt64>());
         if(name == "/std_msgs/UInt16")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::UInt16>());
         if(name == "/std_msgs/Byte")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::Byte>());
         if(name == "/std_msgs/Bool")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::Bool>());
         if(name == "/std_msgs/ByteMultiArray")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::ByteMultiArray>());
         if(name == "/std_msgs/Float32")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::Float32>());
         if(name == "/std_msgs/String")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::String>());
         if(name == "/std_msgs/UInt8")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::UInt8>());
         if(name == "/std_msgs/Char")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::Char>());
         if(name == "/std_msgs/Float64MultiArray")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::Float64MultiArray>());
         if(name == "/std_msgs/UInt32")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::UInt32>());
         if(name == "/std_msgs/Header")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::Header>());
         if(name == "/std_msgs/Int16MultiArray")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::Int16MultiArray>());
         if(name == "/std_msgs/UInt32MultiArray")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::UInt32MultiArray>());
         if(name == "/std_msgs/Int16")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::Int16>());
         if(name == "/std_msgs/UInt16MultiArray")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::UInt16MultiArray>());
         if(name == "/std_msgs/UInt8MultiArray")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::UInt8MultiArray>());
         if(name == "/std_msgs/MultiArrayDimension")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::MultiArrayDimension>());
         if(name == "/std_msgs/Int64")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::Int64>());
         if(name == "/std_msgs/Time")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::Time>());
         if(name == "/std_msgs/Int64MultiArray")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::Int64MultiArray>());
         if(name == "/std_msgs/Empty")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::Empty>());
         if(name == "/std_msgs/Int8MultiArray")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::Int8MultiArray>());
         if(name == "/std_msgs/MultiArrayLayout")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::MultiArrayLayout>());
         if(name == "/std_msgs/UInt64MultiArray")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::UInt64MultiArray>());
         if(name == "/std_msgs/Int8")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::Int8>());
         if(name == "/std_msgs/Int32")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::Int32>());
         if(name == "/std_msgs/Float64")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::Float64>());
         if(name == "/std_msgs/ColorRGBA")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::ColorRGBA>());
         if(name == "/std_msgs/Duration")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::Duration>());
         if(name == "/std_msgs/Float32MultiArray")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::Float32MultiArray>());
         if(name == "/std_msgs/Int32MultiArray")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<std_msgs::Int32MultiArray>());

          return false;
      }
      
      std::string getTransportName() const {
          return "ros";
      }
      
      std::string getTypekitName() const {
          return std::string("ros-")+"std_msgs";
      }
      std::string getName() const {
          return std::string("rtt-ros-") + "std_msgs" + "-transport";
      }

    };
}

ORO_TYPEKIT_PLUGIN( ros_integration::ROSstd_msgsPlugin )
